diff --git a/linux-2.6.37.6-antonio/ipc/stm.h b/linux-2.6.37.6-antonio/ipc/stm.h
new file mode 100644
index 0000000..51fe22b
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm.h
@@ -0,0 +1,273 @@
+/*
+ * stm.h
+ *
+ *  Created on: Dec 12, 2011
+ *      Author: Antonio Barbalace <antoniob@vt.edu>
+ */
+
+#ifndef STM_H_
+#define STM_H_
+
+#ifdef CONFIG_STM_DEBUG
+# define STM_DEBUG
+#endif /* ! CONFIG_STM_DEBUG */
+#ifdef CONFIG_STM_DEBUG2
+# define STM_DEBUG2
+#endif /* ! CONFIG_STM_DEBUG2 */
+#ifdef CONFIG_STM_DEBUG3
+# define STM_DEBUG3
+#endif /* ! CONFIG_STM_DEBUG3 */
+
+// #undef STM_DEBUG3
+// #undef STM_DEBUG2
+// #undef STM_DEBUG
+//#define STM_DEBUG3
+//#define STM_DEBUG2
+//#define STM_DEBUG
+
+#ifdef STM_DEBUG3
+# ifndef STM_DEBUG2
+#  define STM_DEBUG2
+# endif /* ! DEBUG */
+#endif /* DEBUG2 */
+
+#ifdef STM_DEBUG2
+# ifndef STM_DEBUG
+#  define STM_DEBUG
+# endif /* ! DEBUG */
+#endif /* DEBUG2 */
+
+#ifdef STM_DEBUG
+//# define PRINT_DEBUG(a, args...)			printk("%s: " a , __func__, ##args)
+# define PRINT_DEBUG(...)               trace_printk(__VA_ARGS__)
+#else /* ! DEBUG */
+# define IO_FLUSH
+# define PRINT_DEBUG(...)
+#endif /* ! DEBUG */
+
+#ifdef STM_DEBUG2
+# define PRINT_DEBUG2(...)              PRINT_DEBUG(__VA_ARGS__)
+#else /* ! DEBUG2 */
+# define PRINT_DEBUG2(...)
+#endif /* ! DEBUG2 */
+
+#ifdef STM_DEBUG3
+# define PRINT_DEBUG3(...)              PRINT_DEBUG2(__VA_ARGS__)
+#else /* ! DEBUG3 */
+# define PRINT_DEBUG3(...)
+#endif /* ! DEBUG3 */
+
+#define PRINT_ERR(a, args...)			printk("%s: " a , __func__, ##args)
+#define PERROR(...)						PRINT_ERR(__VA_ARGS__)
+
+#if CM == CM_BACKOFF
+# ifndef MIN_BACKOFF
+#  define MIN_BACKOFF                   (1UL << 2)
+# endif /* MIN_BACKOFF */
+# ifndef MAX_BACKOFF
+#  define MAX_BACKOFF                   (1UL << 31)
+# endif /* MAX_BACKOFF */
+#endif /* CM == CM_BACKOFF */
+
+#if CM == CM_MODULAR
+# define VR_THRESHOLD                   "VR_THRESHOLD"
+# ifndef VR_THRESHOLD_DEFAULT
+#  define VR_THRESHOLD_DEFAULT          3
+# endif /* VR_THRESHOLD_DEFAULT */
+static int vr_threshold;
+#endif /* CM == CM_MODULAR */
+
+#define NO_SIGNAL_HANDLER               "NO_SIGNAL_HANDLER"
+
+#define XSTR(s)                         STR(s)
+#define STR(s)                          #s
+
+/* ################################################################### *
+ * TYPES
+ * ################################################################### */
+
+enum {                                  /* Transaction status */
+  TX_IDLE = 0,
+  TX_ACTIVE = 1,                        /* Lowest bit indicates activity */
+  TX_COMMITTED = (1 << 1),
+  TX_ABORTED = (2 << 1),
+  TX_COMMITTING = (1 << 1) | TX_ACTIVE,
+  TX_ABORTING = (2 << 1) | TX_ACTIVE,
+  TX_KILLED = (3 << 1) | TX_ACTIVE,
+  TX_IRREVOCABLE = 0x08 | TX_ACTIVE     /* Fourth bit indicates irrevocability */
+};
+#define STATUS_BITS                     4
+#define STATUS_MASK                     ((1 << STATUS_BITS) - 1)
+
+#if CM == CM_MODULAR
+# define SET_STATUS(s, v)               ATOMIC_STORE_REL(&(s), ((s) & ~(stm_word_t)STATUS_MASK) | (v))
+# define INC_STATUS_COUNTER(s)          ((((s) >> STATUS_BITS) + 1) << STATUS_BITS)
+# define UPDATE_STATUS(s, v)            ATOMIC_STORE_REL(&(s), INC_STATUS_COUNTER(s) | (v))
+# define GET_STATUS(s)                  ((s) & STATUS_MASK)
+# define GET_STATUS_COUNTER(s)          ((s) >> STATUS_BITS)
+#else /* CM != CM_MODULAR */
+# define SET_STATUS(s, v)               ((s) = (v))
+# define UPDATE_STATUS(s, v)            ((s) = (v))
+# define GET_STATUS(s)                  ((s))
+#endif /* CM != CM_MODULAR */
+#define IS_ACTIVE(s)                    ((GET_STATUS(s) & 0x01) == TX_ACTIVE)
+
+#include <linux/stm_types.h>
+
+static int nb_specific = 0;             /* Number of specific slots used (<= MAX_SPECIFIC) */
+
+static int initialized = 0;             /* Has the library been initialized? */
+
+#ifdef IRREVOCABLE_ENABLED
+static volatile stm_word_t irrevocable = 0;
+#endif /* IRREVOCABLE_ENABLED */
+
+/* ################################################################### *
+ * CALLBACKS
+ * ################################################################### */
+/* functionality disabled for kernel portability (not easy in kernel (at least we can provide a list of in kernel notifiers
+#define MAX_CB                          16
+
+// Declare as static arrays (vs. lists) to improve cache locality
+static cb_entry_t init_cb[MAX_CB];      // Init thread callbacks
+static cb_entry_t exit_cb[MAX_CB];      // Exit thread callbacks
+static cb_entry_t start_cb[MAX_CB];     // Start callbacks
+static cb_entry_t commit_cb[MAX_CB];    // Commit callbacks
+static cb_entry_t abort_cb[MAX_CB];     // Abort callbacks
+*/
+/*
+static int nb_init_cb = 0;
+static int nb_exit_cb = 0;
+static int nb_start_cb = 0;
+static int nb_commit_cb = 0;
+static int nb_abort_cb = 0;
+*/
+#ifdef CONFLICT_TRACKING
+static void (*conflict_cb)(stm_tx_t *, stm_tx_t *) = NULL;
+#endif /* CONFLICT_TRACKING */
+
+/* ################################################################### *
+ * LOCKS
+ * ################################################################### */
+
+/*
+ * A lock is a unsigned int of the size of a pointer.
+ * The LSB is the lock bit. If it is set, this means:
+ * - At least some covered memory addresses is being written.
+ * - Write-back (ETL): all bits of the lock apart from the lock bit form
+ *   a pointer that points to the write log entry holding the new
+ *   value. Multiple values covered by the same log entry and orginized
+ *   in a linked list in the write log.
+ * - Write-through and write-back (CTL): all bits of the lock apart from
+ *   the lock bit form a pointer that points to the transaction
+ *   descriptor containing the write-set.
+ * If the lock bit is not set, then:
+ * - All covered memory addresses contain consistent values.
+ * - Write-back (ETL and CTL): all bits of the lock besides the lock bit
+ *   contain a version number (timestamp).
+ * - Write-through: all bits of the lock besides the lock bit contain a
+ *   version number.
+ *   - The high order bits contain the commit time.
+ *   - The low order bits contain an incarnation number (incremented
+ *     upon abort while writing the covered memory addresses).
+ * When visible reads are enabled, two bits are used as read and write
+ * locks. A read-locked address can be read by an invisible reader.
+ */
+
+#if CM == CM_MODULAR
+# define OWNED_BITS                     2                   /* 2 bits */
+# define WRITE_MASK                     0x01                /* 1 bit */
+# define READ_MASK                      0x02                /* 1 bit */
+# define OWNED_MASK                     (WRITE_MASK | READ_MASK)
+#else /* CM != CM_MODULAR */
+# define OWNED_BITS                     1                   /* 1 bit */
+# define WRITE_MASK                     0x01                /* 1 bit */
+# define OWNED_MASK                     (WRITE_MASK)
+#endif /* CM != CM_MODULAR */
+#if DESIGN == WRITE_THROUGH
+# define INCARNATION_BITS               3                   /* 3 bits */
+# define INCARNATION_MAX                ((1 << INCARNATION_BITS) - 1)
+# define INCARNATION_MASK               (INCARNATION_MAX << 1)
+# define LOCK_BITS                      (OWNED_BITS + INCARNATION_BITS)
+#else /* DESIGN != WRITE_THROUGH */
+# define LOCK_BITS                      (OWNED_BITS)
+#endif /* DESIGN != WRITE_THROUGH */
+#define MAX_THREADS                     8192                /* Upper bound (large enough) */
+#define VERSION_MAX                     ((~(stm_word_t)0 >> LOCK_BITS) - MAX_THREADS)
+#define LOCK_GET_OWNED(l)               (l & OWNED_MASK)
+#define LOCK_GET_WRITE(l)               (l & WRITE_MASK)
+#define LOCK_SET_ADDR_WRITE(a)          (a | WRITE_MASK)    /* WRITE bit set */
+#define LOCK_GET_ADDR(l)                (l & ~(stm_word_t)OWNED_MASK)
+#if CM == CM_MODULAR
+# define LOCK_GET_READ(l)               (l & READ_MASK)
+# define LOCK_SET_ADDR_READ(a)          (a | READ_MASK)     /* READ bit set */
+# define LOCK_UPGRADE(l)                (l | WRITE_MASK)
+#endif /* CM == CM_MODULAR */
+#if DESIGN == WRITE_THROUGH
+# define LOCK_GET_TIMESTAMP(l)          (l >> (1 + INCARNATION_BITS))
+# define LOCK_SET_TIMESTAMP(t)          (t << (1 + INCARNATION_BITS))
+# define LOCK_GET_INCARNATION(l)        ((l & INCARNATION_MASK) >> 1)
+# define LOCK_SET_INCARNATION(i)        (i << 1)            /* OWNED bit not set */
+# define LOCK_UPD_INCARNATION(l, i)     ((l & ~(stm_word_t)(INCARNATION_MASK | OWNED_MASK)) | LOCK_SET_INCARNATION(i))
+#else /* DESIGN != WRITE_THROUGH */
+# define LOCK_GET_TIMESTAMP(l)          (l >> OWNED_BITS)   /* Logical shift (unsigned) */
+# define LOCK_SET_TIMESTAMP(t)          (t << OWNED_BITS)   /* OWNED bits not set */
+#endif /* DESIGN != WRITE_THROUGH */
+#define LOCK_UNIT                       (~(stm_word_t)0)
+
+/*
+ * We use the very same hash functions as TL2 for degenerate Bloom
+ * filters on 32 bits.
+ */
+#ifdef USE_BLOOM_FILTER
+# define FILTER_HASH(a)                 (((stm_word_t)a >> 2) ^ ((stm_word_t)a >> 5))
+# define FILTER_BITS(a)                 (1 << (FILTER_HASH(a) & 0x1F))
+#endif /* USE_BLOOM_FILTER */
+
+/*
+ * We use an array of locks and hash the address to find the location of the lock.
+ * We try to avoid collisions as much as possible (two addresses covered by the same lock).
+ */
+#define LOCK_ARRAY_SIZE                 (1 << LOCK_ARRAY_LOG_SIZE)
+#define LOCK_MASK                       (LOCK_ARRAY_SIZE - 1)
+#define LOCK_SHIFT                      (((sizeof(stm_word_t) == 4) ? 2 : 3) + LOCK_SHIFT_EXTRA)
+#define LOCK_IDX(a)                     (((stm_word_t)(a) >> LOCK_SHIFT) & LOCK_MASK)
+#ifdef LOCK_IDX_SWAP
+# if LOCK_ARRAY_LOG_SIZE < 16
+#  error "LOCK_IDX_SWAP requires LOCK_ARRAY_LOG_SIZE to be at least 16"
+# endif /* LOCK_ARRAY_LOG_SIZE < 16 */
+# define GET_LOCK(a)                    (locks + lock_idx_swap(LOCK_IDX(a)))
+#else /* ! LOCK_IDX_SWAP */
+# define GET_LOCK(a)                    (locks + LOCK_IDX(a))
+#endif /* ! LOCK_IDX_SWAP */
+
+static volatile stm_word_t locks[LOCK_ARRAY_SIZE];
+
+# ifdef WAIT_COND
+  struct mutex locks_mutex[LOCK_ARRAY_SIZE];			/* Mutex to support CM_DELAY*/
+  wait_queue_head_t locks_cond[LOCK_ARRAY_SIZE];			/* Conditional Variable to to support CM_DELAY*/
+# endif /* WAIT_COND */
+
+/* ################################################################### *
+ * CLOCK
+ * ################################################################### */
+
+#ifdef CLOCK_IN_CACHE_LINE
+/* At least twice a cache line (512 bytes to be on the safe side) */
+static volatile stm_word_t gclock[1024 / sizeof(stm_word_t)];
+# define CLOCK                          (gclock[512 / sizeof(stm_word_t)])
+#else /* ! CLOCK_IN_CACHE_LINE */
+static volatile stm_word_t gclock;
+# define CLOCK                          (gclock)
+#endif /* ! CLOCK_IN_CACHE_LINE */
+
+#define GET_CLOCK                       (ATOMIC_LOAD_ACQ(&CLOCK))
+#define FETCH_INC_CLOCK                 (ATOMIC_FETCH_INC_FULL(&CLOCK))
+
+#endif /* STM_H_ */
+
+
+#define ROLLBACK_REQUESTED	-1
+#define ROLLBACK_NO_RETRY	0
+#define SUCCESS				1
+
diff --git a/linux-2.6.37.6-antonio/ipc/stm.readme b/linux-2.6.37.6-antonio/ipc/stm.readme
new file mode 100644
index 0000000..6835403
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm.readme
@@ -0,0 +1,50 @@
+VT RTSL Linux TM  
+
+release 0.3 (still buggy) 
+? april 2012 - Antonio Barbalace
+-------------------------------------------------------------------------------
+added support to proc, a lot of improvements and scheduling features were added.
+preemption avoidance with bonus, migration avoidance.
+retry from user space is still not working, todo.
+
+
+
+release 0.2 (first attempt.. much more work is required for a release) 
+? feb 2012 - Antonio Barbalace
+-------------------------------------------------------------------------------
+support stat and param syscalls in krn/user; add mod_stat to kernel space;
+all statistics are collected in kernel space (per thread and global statistics)
+this choice have a lot of sense all statistics are integrated in kernel.
+We can let user space application to register hook to each event as it is in
+TinySTM. This is ok for malloc, but also malloc cam be directly integrated (to
+be decided)..
+mod_log will be supported with ftrace
+
+
+
+release 0.1
+31 jan 2012 - Antonio Barbalace
+-------------------------------------------------------------------------------
+
+This first release does not support system wide (inter process) stm.
+Neither it guarentees support for different process running the stm layer
+concurrently (due to the fact that stm addresses are not grupped by process
+address space).
+The code base from which we started is the open-source TinySTM.
+We are trying to getting around this code in the future versions of our
+implementation. Not all TinySTM functionality are implemented.
+
+TODO
+- user space access from kernel flushing reads and writes
+- add kernel configuration options to kernel configuration
+- group r/w entries per address space ( search for thread in the same process in
+  quiesce support )
+- enable inter process stm (shared memory support)
+- improve quiescence groupping thread with common read/write set (new
+  algorithms are needed)
+- add EPOCH_GC (in user space maybe)
+- add malloc/free support in user space
+- export statistics/parameters and other data from /proc/thread
+- merge local and internal stats
+- move all stats code in one unique file
+
diff --git a/linux-2.6.37.6-antonio/ipc/stm_atomic.h b/linux-2.6.37.6-antonio/ipc/stm_atomic.h
new file mode 100644
index 0000000..61fbae0
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_atomic.h
@@ -0,0 +1,107 @@
+/*
+ * File:
+ *   atomic.h
+ * Author(s):
+ *   Pascal Felber <pascal.felber@unine.ch> - original version
+ *   Antonio Barbalace <antoniob@vt.edu> - Linux Kernel porting
+ * Description:
+ *   Atomic operations.
+ *
+ * Copyright (c) 2007-2009.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, version 2
+ * of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef _ATOMIC_H_
+# define _ATOMIC_H_
+
+
+//# include <atomic_ops.h> //previous version
+//the Linux atomic library makes atomic operations on integers (atomic is 32bit
+//in asm/atomic.h) 64bit support is provided by asm/atomic64_32.h and asm/atomic64_64.h
+//linux/atomic.h includes asm/atomic.h that includes atomic64_32.h or atomic64_64.h
+#include <linux/atomic.h> //Linux kernel version
+
+//memory barriers
+//this is platform specific
+#include <asm/system.h> //Linux kernel version
+//this is more compiler specific, compiler will find the best match (barrier)
+//#include <linux/compiler.h> //Linux kernel version
+
+//#define AO_t uintptr_t
+//typedef AO_t atomic_t;
+
+
+# ifdef NO_AO
+/* Use only for testing purposes (single thread benchmarks) */
+
+// 8/16/32/64 BITS
+#  define ATOMIC_CAS_FULL(a, e, v)      (*(a) = (v), 1)
+#  define ATOMIC_FETCH_INC_FULL(a)      ((*(a))++)
+#  define ATOMIC_FETCH_DEC_FULL(a)      ((*(a))--)
+#  define ATOMIC_FETCH_ADD_FULL(a, v)   ((*(a)) += (v))
+#  define ATOMIC_LOAD_ACQ(a)            (*(a))
+#  define ATOMIC_LOAD(a)                (*(a))
+#  define ATOMIC_STORE_REL(a, v)        (*(a) = (v))
+#  define ATOMIC_STORE(a, v)            (*(a) = (v))
+#  define ATOMIC_MB_READ                /* Nothing */
+#  define ATOMIC_MB_WRITE               /* Nothing */
+#  define ATOMIC_MB_FULL                /* Nothing */
+# else /* ! NO_AO */
+/* the following implementation is a Linux kernel wrapper */
+
+#ifndef CONFIG_64BIT
+// 32 BITS
+//AO_compare_and_swap_full(volatile AO_t *addr, AO_t old, AO_t new_val)
+//#  define ATOMIC_CAS_FULL(a, e, v)      (AO_compare_and_swap_full((volatile AO_t *)(a), (AO_t)(e), (AO_t)(v)))
+#  define ATOMIC_CAS_FULL(a, e, v)      (atomic_cmpxchg((atomic_t *)(a),(int)(e),(int)(v)))
+//AO_fetch_and_add_full (volatile AO_t *p, AO_t incr)
+//#  define AO_fetch_and_add1_full(addr) AO_fetch_and_add_full(addr,1)
+#  define ATOMIC_FETCH_INC_FULL(a)      (atomic_inc_return((atomic_t *)(a)))
+//#  define ATOMIC_FETCH_DEC_FULL(a)      (AO_fetch_and_sub1_full((volatile AO_t *)(a)))
+#  define ATOMIC_FETCH_DEC_FULL(a)      (atomic_dec_return((atomic_t *)(a)))
+//#  define ATOMIC_FETCH_ADD_FULL(a, v)   (AO_fetch_and_add_full((volatile AO_t *)(a), (AO_t)(v)))
+#  define ATOMIC_FETCH_ADD_FULL(a, v)   (atomic_add_return((int)(v),(atomic_t *)(a)))
+//#   define ATOMIC_LOAD(a)               (*((volatile AO_t *)(a)))
+#  define ATOMIC_LOAD(a)               atomic_read((atomic_t *) a)
+//#   define ATOMIC_STORE(a, v)           (*((volatile AO_t *)(a)) = (AO_t)(v))
+#  define ATOMIC_STORE(a, v)           atomic_set((atomic_t *) a, v)
+
+#else /* CONFIG_64BIT */
+// 64 BITS
+#  define ATOMIC_CAS_FULL(a, e, v)      (atomic64_cmpxchg((atomic64_t *)(a),(long)(e),(long)(v)))
+#  define ATOMIC_FETCH_INC_FULL(a)      (atomic64_inc_return((atomic64_t *)(a)))
+#  define ATOMIC_FETCH_DEC_FULL(a)      (atomic64_dec_return((atomic64_t *)(a)))
+#  define ATOMIC_FETCH_ADD_FULL(a, v)   (atomic64_add_return((long)(v),(atomic64_t *)(a)))
+#  define ATOMIC_LOAD(a)               atomic64_read((atomic64_t *) a)
+#  define ATOMIC_STORE(a, v)           atomic64_set((atomic64_t *) a, v)
+
+#endif /* CONFIG_64BIT */
+
+//#  define ATOMIC_MB_READ               AO_nop_read()
+#  define ATOMIC_MB_READ               smp_rmb()
+//#  define ATOMIC_MB_READ               AO_nop_write()
+#  define ATOMIC_MB_WRITE              smp_wmb()
+//#  define ATOMIC_MB_FULL               AO_nop_full()
+#  define ATOMIC_MB_FULL               smp_mb()
+
+#ifndef CONFIG_64BIT
+#   define ATOMIC_LOAD_ACQ(a)           ({int i = ATOMIC_LOAD(a); ATOMIC_MB_READ; i;})
+#else
+#   define ATOMIC_LOAD_ACQ(a)           ({long i = ATOMIC_LOAD(a); ATOMIC_MB_READ; i;})
+#endif
+#   define ATOMIC_STORE_REL(a, v)       ({ATOMIC_MB_WRITE; ATOMIC_STORE(a, v);})
+
+//TODO 64bit version
+
+# endif /* ! NO_AO */
+
+#endif /* _ATOMIC_H_ */
diff --git a/linux-2.6.37.6-antonio/ipc/stm_cm.h b/linux-2.6.37.6-antonio/ipc/stm_cm.h
new file mode 100644
index 0000000..e01e7a9
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_cm.h
@@ -0,0 +1,46 @@
+/*
+ * stm_cm.h
+ *
+ *  Created on: Dec 13, 2011
+ *      Author: root
+ */
+
+#ifndef STM_CM_H_
+#define STM_CM_H_
+
+
+
+
+
+
+
+
+static const char *cm_names[] = {
+  /* 0 */ "SUICIDE",
+  /* 1 */ "DELAY",
+  /* 2 */ "BACKOFF",
+  /* 3 */ "MODULAR"
+};
+
+
+
+#if DESIGN != WRITE_BACK_ETL && CM == CM_MODULAR
+# error "MODULAR contention manager can only be used with WB-ETL design"
+#endif /* DESIGN != WRITE_BACK_ETL && CM == CM_MODULAR */
+
+#if defined(CONFLICT_TRACKING) && ! defined(EPOCH_GC)
+# error "CONFLICT_TRACKING requires EPOCH_GC"
+#endif /* defined(CONFLICT_TRACKING) && ! defined(EPOCH_GC) */
+
+#if CM == CM_MODULAR && ! defined(EPOCH_GC)
+# error "MODULAR contention manager requires EPOCH_GC"
+#endif /* CM == CM_MODULAR && ! defined(EPOCH_GC) */
+
+#if defined(READ_LOCKED_DATA) && CM != CM_MODULAR
+# error "READ_LOCKED_DATA can only be used with MODULAR contention manager"
+#endif /* defined(READ_LOCKED_DATA) && CM != CM_MODULAR */
+
+
+
+
+#endif /* STM_CM_H_ */
diff --git a/linux-2.6.37.6-antonio/ipc/stm_cm_modular.h b/linux-2.6.37.6-antonio/ipc/stm_cm_modular.h
new file mode 100644
index 0000000..5ee1b4c
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_cm_modular.h
@@ -0,0 +1,82 @@
+/*
+ * stm_cm_modular.h
+ *
+ *  Created on: Jan 4, 2012
+ *      Author: root
+ */
+
+#ifndef STM_CM_MODULAR_H_
+#define STM_CM_MODULAR_H_
+
+# define KILL_SELF                      0x00
+# define KILL_OTHER                     0x01
+# define DELAY_RESTART                  0x04
+
+# define RR_CONFLICT                    0x00
+# define RW_CONFLICT                    0x01
+# define WR_CONFLICT                    0x02
+# define WW_CONFLICT                    0x03
+
+static int (*contention_manager)(stm_tx_t *, stm_tx_t *, int) = NULL;
+
+/*
+ * Kill other.
+ */
+int cm_aggressive(struct stm_tx *me, struct stm_tx *other, int conflict)
+{
+  return KILL_OTHER;
+}
+
+/*
+ * Kill self.
+ */
+int cm_suicide(struct stm_tx *me, struct stm_tx *other, int conflict)
+{
+  return KILL_SELF;
+}
+
+/*
+ * Kill self and wait before restart.
+ */
+int cm_delay(struct stm_tx *me, struct stm_tx *other, int conflict)
+{
+  return KILL_SELF | DELAY_RESTART;
+}
+
+/*
+ * Oldest transaction has priority.
+ */
+int cm_timestamp(struct stm_tx *me, struct stm_tx *other, int conflict)
+{
+  if (me->timestamp < other->timestamp)
+    return KILL_OTHER;
+  if (me->timestamp == other->timestamp && (uintptr_t)me < (uintptr_t)other)
+    return KILL_OTHER;
+  return KILL_SELF | DELAY_RESTART;
+}
+
+/*
+ * Transaction with more work done has priority.
+ */
+int cm_karma(struct stm_tx *me, struct stm_tx *other, int conflict)
+{
+  if ((me->w_set.nb_entries << 1) + me->r_set.nb_entries < (other->w_set.nb_entries << 1) + other->r_set.nb_entries)
+    return KILL_OTHER;
+  if (((me->w_set.nb_entries << 1) + me->r_set.nb_entries == (other->w_set.nb_entries << 1) + other->r_set.nb_entries) && (uintptr_t)me < (uintptr_t)other )
+    return KILL_OTHER;
+  return KILL_SELF;
+}
+
+struct {
+  const char *name;
+  int (*f)(stm_tx_t *, stm_tx_t *, int);
+} cms[] = {
+  { "aggressive", cm_aggressive },
+  { "suicide", cm_suicide },
+  { "delay", cm_delay },
+  { "timestamp", cm_timestamp },
+  { "karma", cm_karma },
+  { NULL, NULL }
+};
+
+#endif /* STM_CM_MODULAR_H_ */
diff --git a/linux-2.6.37.6-antonio/ipc/stm_design.h b/linux-2.6.37.6-antonio/ipc/stm_design.h
new file mode 100644
index 0000000..e111208
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_design.h
@@ -0,0 +1,26 @@
+/*
+ * stm_design.h
+ *
+ *  Created on: Dec 13, 2011
+ *      Author: root
+ */
+
+#ifndef STM_DESIGN_H_
+#define STM_DESIGN_H_
+
+
+
+
+
+
+static const char *design_names[] = {
+  /* 0 */ "WRITE-BACK (ETL)",
+  /* 1 */ "WRITE-BACK (CTL)",
+  /* 2 */ "WRITE-THROUGH"
+};
+
+
+
+
+
+#endif /* STM_DESIGN_H_ */
diff --git a/linux-2.6.37.6-antonio/ipc/stm_mod_stats.h b/linux-2.6.37.6-antonio/ipc/stm_mod_stats.h
new file mode 100644
index 0000000..3a82c32
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_mod_stats.h
@@ -0,0 +1,230 @@
+/*
+ * stm_mod_stats.c
+ *
+ *  Created on: Jan 17, 2012
+ *      Author: root
+ */
+
+
+/* WAS
+ * File:
+ *   mod_stats.c
+ * Author(s):
+ *   Pascal Felber <pascal.felber@unine.ch>
+ * Description:
+ *   Module for gathering global statistics about transactions.
+ *
+ * Copyright (c) 2007-2009.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, version 2
+ * of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+//#include <assert.h>
+#include <linux/limits.h>
+//#include <stdio.h>
+//#include <string.h>
+
+//#include "mod_stats.h"
+
+//#include "atomic.h"
+//#include "stm.h"
+
+
+
+//static int mod_stats_key;
+static int mod_stats_initialized = 0;
+
+static mod_stats_data_t mod_stats_global = { 0, 0, ULONG_MAX, 0, 0, 0 };
+
+/* ################################################################### *
+ * GET FUNCTIONS
+ * ################################################################### */
+
+/*
+ * Return aggregate statistics about transactions.
+ */
+int stm_get_global_stats(const char *name, void *val)
+{
+  /*if (!mod_stats_initialized) {
+    fprintf(stderr, "Module mod_stats not initialized\n");
+    exit(1);
+  }
+*/
+  if (strcmp("global_nb_commits", name) == 0) {
+    *(unsigned long *)val = mod_stats_global.commits;
+    return 1;
+  }
+  if (strcmp("global_nb_aborts", name) == 0) {
+    *(unsigned long *)val = mod_stats_global.retries_acc;
+    return 1;
+  }
+  if (strcmp("global_max_retries", name) == 0) {
+    *(unsigned long *)val = mod_stats_global.retries_max;
+    return 1;
+  }
+
+  return 0;
+}
+
+/*
+ * Return statistics about current thread.
+ */
+int stm_get_local_stats(TXPARAMS const char *name, void *val)
+{
+	TX_GET;
+  mod_stats_data_t *stats = &(tx->mod_stats);
+
+/*  if (!mod_stats_initialized) {
+    fprintf(stderr, "Module mod_stats not initialized\n");
+    exit(1);
+  }*/
+
+//  stats = (mod_stats_data_t *)stm_get_specific(TXARGS mod_stats_key);
+//  assert(stats != NULL);
+
+  if (strcmp("nb_commits", name) == 0) {
+    *(unsigned long *)val = stats->commits;
+    return 1;
+  }
+  if (strcmp("nb_aborts", name) == 0) {
+    *(unsigned long *)val = stats->retries_acc;
+    return 1;
+  }
+  if (strcmp("nb_retries_avg", name) == 0) {
+    *(unsigned long *)val = (stats->retries_acc / stats->retries_cnt);
+    return 1;
+  }
+  if (strcmp("nb_retries_min", name) == 0) {
+    *(unsigned long *)val = stats->retries_min;
+    return 1;
+  }
+  if (strcmp("nb_retries_max", name) == 0) {
+    *(unsigned long *)val = stats->retries_max;
+    return 1;
+  }
+
+  return 0;
+}
+
+/* ################################################################### *
+ * Hook FUNCTIONS
+ * ################################################################### */
+
+/*
+ * Called upon thread creation.
+ */
+static inline void mod_stats_on_thread_init(stm_tx_t * tx)
+{
+	//TX_GET; not working in this context!!!
+  mod_stats_data_t *stats = &(tx->mod_stats);
+
+// stats are allocated in the transaction descriptor
+/*  if ((stats = (mod_stats_data_t *)malloc(sizeof(mod_stats_data_t))) == NULL) {
+    perror("malloc");
+    exit(1);
+  }
+*/  stats->commits = 0;
+  stats->retries = 0;
+  stats->retries_acc = 0;
+  stats->retries_cnt = 0;
+  stats->retries_min = ULONG_MAX;
+  stats->retries_max = 0;
+
+//  stm_set_specific(TXARGS mod_stats_key, stats);
+}
+
+/*
+ * Called upon thread deletion.
+ */
+static void mod_stats_on_thread_exit(void)
+{
+	TX_GET;
+  mod_stats_data_t *stats = &(tx->mod_stats);
+
+  unsigned long max, min;
+
+//  stats = (mod_stats_data_t *)stm_get_specific(TXARGS mod_stats_key);
+//  assert(stats != NULL);
+
+  ATOMIC_FETCH_ADD_FULL(&mod_stats_global.commits, stats->commits);
+  ATOMIC_FETCH_ADD_FULL(&mod_stats_global.retries_cnt, stats->retries_cnt);
+  ATOMIC_FETCH_ADD_FULL(&mod_stats_global.retries_acc, stats->retries_acc);
+retry_max:
+  max = ATOMIC_LOAD(&mod_stats_global.retries_max);
+  if (stats->retries_max > max) {
+    if (ATOMIC_CAS_FULL(&mod_stats_global.retries_max, max, stats->retries_max) == 0)
+      goto retry_max;
+  }
+retry_min:
+  min = ATOMIC_LOAD(&mod_stats_global.retries_min);
+  if (stats->retries_min < min) {
+    if (ATOMIC_CAS_FULL(&mod_stats_global.retries_min, min, stats->retries_min) == 0)
+      goto retry_min;
+  }
+
+//  free(stats);
+}
+
+/*
+ * Called upon transaction commit.
+ */
+static void mod_stats_on_commit(void)
+{
+	TX_GET;
+  mod_stats_data_t *stats = &(tx->mod_stats);
+
+
+//  stats = (mod_stats_data_t *)stm_get_specific(TXARGS mod_stats_key);
+//  assert(stats != NULL);
+
+  stats->commits++;
+  stats->retries_acc += stats->retries;
+  stats->retries_cnt++;
+  if (stats->retries_min > stats->retries)
+    stats->retries_min = stats->retries;
+  if (stats->retries_max < stats->retries)
+    stats->retries_max = stats->retries;
+  stats->retries = 0;
+}
+
+/*
+ * Called upon transaction abort.
+ */
+static void mod_stats_on_abort(void)
+{
+	TX_GET;
+  mod_stats_data_t *stats = &(tx->mod_stats);
+
+
+//  stats = (mod_stats_data_t *)stm_get_specific(TXARGS mod_stats_key);
+//  assert(stats != NULL);
+
+  stats->retries++;
+}
+
+/*
+ * Initialize module.
+ */
+/*
+void mod_stats_init()
+{
+  if (mod_stats_initialized)
+    return;
+
+  stm_register(mod_stats_on_thread_init, mod_stats_on_thread_exit, NULL, mod_stats_on_commit, mod_stats_on_abort, NULL);
+  mod_stats_key = stm_create_specific();
+  if (mod_stats_key < 0) {
+    fprintf(stderr, "Cannot create specific key\n");
+    exit(1);
+  }
+  mod_stats_initialized = 1;
+}
+*/
